# from flask import Flask, render_template, jsonify
# import time
# import threading

# app = Flask(__name__)
# emotions = []

# def get_emotion_data():
#     global emotions
#     while True:
#         # Assuming detect_emotions updates the global 'emotions' list
#         time.sleep(1)  # Adjust the delay as needed

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def emotion_data():
#     return jsonify(emotions)

# if __name__ == '__main__':
#     # Start emotion detection in a separate thread
#     threading.Thread(target=get_emotion_data, daemon=True).start()
#     app.run(debug=True)

# from flask import Flask, render_template, request, jsonify
# import threading

# app = Flask(__name__)
# emotion_data = {'emotion': ''}

# def update_emotion_data(emotion):
#     global emotion_data
#     emotion_data['emotion'] = emotion

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def get_emotion_data():
#     return jsonify(emotion_data)

# @app.route('/update_emotion', methods=['POST'])
# def update_emotion():
#     global emotion_data
#     data = request.json
#     emotion = data.get('emotion')
#     update_emotion_data(emotion)
#     return jsonify({'status': 'success'})

# if __name__ == '__main__':
#     app.run(debug=True)

# from flask import Flask, render_template, request, jsonify
# import threading
# import logging

# app = Flask(__name__)
# logging.basicConfig(level=logging.DEBUG)  # Enable logging
# emotion_data = {'emotion': ''}

# def update_emotion_data(emotion):
#     global emotion_data
#     emotion_data['emotion'] = emotion
#     logging.debug(f"Updated emotion data: {emotion_data}")

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def get_emotion_data():
#     return jsonify(emotion_data)

# @app.route('/update_emotion', methods=['POST'])
# def update_emotion():
#     global emotion_data
#     data = request.json
#     emotion = data.get('emotion')
#     update_emotion_data(emotion)
#     return jsonify({'status': 'success'})

# if __name__ == '__main__':
#     app.run(debug=True)


# import logging
# from flask import Flask, render_template, request, jsonify
# import threading

# app = Flask(__name__)
# logging.basicConfig(level=logging.DEBUG)  # Set logging level to DEBUG
# emotion_data = {'emotion': ''}

# def update_emotion_data(emotion):
#     global emotion_data
#     emotion_data['emotion'] = emotion
#     logging.debug(f"Updated emotion data: {emotion_data}")

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def get_emotion_data():
#     return jsonify(emotion_data)

# @app.route('/update_emotion', methods=['POST'])
# def update_emotion():
#     global emotion_data
#     data = request.json
#     emotion = data.get('emotion')
#     update_emotion_data(emotion)
#     return jsonify({'status': 'success'})

# if __name__ == '__main__':
#     app.run(debug=True)

# WORKING CODE THAT SENDS DATA TO THE SERVER http://172.16.20.180:5000
# from flask import Flask, render_template, request, jsonify
# import threading
# import logging

# app = Flask(__name__)
# logging.basicConfig(level=logging.DEBUG)  # Set logging level to DEBUG
# emotion_data = {'emotion': ''}

# def update_emotion_data(emotion):
#     global emotion_data
#     emotion_data['emotion'] = emotion
#     logging.debug(f"Updated emotion data: {emotion_data}")

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def get_emotion_data():
#     global emotion_data
#     logging.debug(f"Sending emotion data: {emotion_data}")
#     return jsonify(emotion_data)

# @app.route('/update_emotion', methods=['POST'])
# def update_emotion():
#     global emotion_data
#     data = request.json
#     emotion = data.get('emotion')
#     update_emotion_data(emotion)
#     return jsonify({'status': 'success'})

# if __name__ == '__main__':
#     app.run(host='0.0.0.0', debug=True)

# SENDING TO THE WEB SERVER AND RGB LED
# from flask import Flask, render_template, request, jsonify
# import threading
# import logging
# import requests

# app = Flask(__name__)
# logging.basicConfig(level=logging.DEBUG)  # Set logging level to DEBUG
# emotion_data = {'emotion': ''}
# ESP32_IP = 'http://172.16.22.121:5000'  # Replace with your ESP32's IP address

# def update_emotion_data(emotion):
#     global emotion_data
#     emotion_data['emotion'] = emotion
#     logging.debug(f"Updated emotion data: {emotion_data}")
#     # Send emotion data to ESP32
#     try:
#         response = requests.post(f"{ESP32_IP}/update_emotion", json={'emotion': emotion})
#         logging.debug(f"Sent emotion data to ESP32: {response.status_code}")
#     except Exception as e:
#         logging.error(f"Failed to send emotion data to ESP32: {e}")

# @app.route('/')
# def index():
#     return render_template('index.html')

# @app.route('/emotion_data')
# def get_emotion_data():
#     global emotion_data
#     logging.debug(f"Sending emotion data: {emotion_data}")
#     return jsonify(emotion_data)

# @app.route('/update_emotion', methods=['POST'])
# def update_emotion():
#     global emotion_data
#     data = request.json
#     emotion = data.get('emotion')
#     update_emotion_data(emotion)
#     return jsonify({'status': 'success'})

# @app.route('/set_color', methods=['POST'])
# def set_color():
#     data = request.json
#     # Extract RGB color values from the JSON data
#     red = data.get('red')
#     green = data.get('green')
#     blue = data.get('blue')
#     # Implement code to set the color of the RGB LED
#     # Example: set_rgb_led(red, green, blue)
#     return jsonify({'status': 'success'})

# if __name__ == '__main__':
#     app.run(host='0.0.0.0', debug=True)

# CHECKING PORT OF ESP32 it was 80
# import requests

# ESP32_IP = 'http://172.16.22.121'  # Replace with your ESP32's IP address

# try:
#     response = requests.get(f"{ESP32_IP}")
#     print(f"Response from ESP32: {response.text}")
# except Exception as e:
#     print(f"Failed to connect to ESP32: {e}")


# TRYING NEW CODE TO SEND TO ESP

from flask import Flask, render_template, request, jsonify
import logging
import requests

app = Flask(__name__)
logging.basicConfig(level=logging.DEBUG)  # Set logging level to DEBUG
emotion_data = {'emotion': ''}
ESP32_IP = 'http://172.16.22.121'  # Replace with your ESP32's IP address

def update_emotion_data(emotion):
    global emotion_data
    emotion_data['emotion'] = emotion
    logging.debug(f"Updated emotion data: {emotion_data}")
    # Determine RGB values based on emotion and send to ESP32
    if emotion == "happy":
        set_color(255, 255, 0)  # Yellow for happy
    elif emotion == "sad":
        set_color(0, 0, 255)  # Blue for sad
    elif emotion == "angry":
        set_color(255, 0, 0)  # Red for angry
    elif emotion == "surprise":
        set_color(255, 255, 255)  # Teal for surprise
    else:
        set_color(0, 0, 0)  # Off

def set_color(red, green, blue):
    try:
        response = requests.post(f"{ESP32_IP}/set_color", json={'red': red, 'green': green, 'blue': blue})
        logging.debug(f"Sent color data to ESP32: {response.status_code}")
    except Exception as e:
        logging.error(f"Failed to send color data to ESP32: {e}")

@app.route('/')
def index():
    return render_template('index.html')

@app.route('/emotion_data')
def get_emotion_data():
    global emotion_data
    logging.debug(f"Sending emotion data: {emotion_data}")
    return jsonify(emotion_data)

@app.route('/update_emotion', methods=['POST'])
def update_emotion():
    global emotion_data
    data = request.json
    emotion = data.get('emotion')
    update_emotion_data(emotion)
    return jsonify({'status': 'success'})

if __name__ == '__main__':
    app.run(host='0.0.0.0', debug=True)
